<?php
/*
	openbgpd_raw.php
	part of pfSense (https://www.pfSense.org/)
	Copyright (C) 2009 Aarno Aukia (aarnoaukia@gmail.com)
	Copyright (C) 2015 ESF, LLC
	All rights reserved.

	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.

	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.

	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/
require("guiconfig.inc");
require("openbgpd.inc");

global $config;

if (isset($_POST['openbgpd_raw'])) {
	openbgpd_put_raw_config($_POST['openbgpd_raw']);
	write_config();
	openbgpd_install_conf();
}

$openbgpd_raw = openbgpd_get_raw_config();

$pgtitle = array(gettext("Package"), gettext("OpenBGPD"), gettext("Raw Config"));
include("head.inc");

$tab_array = array();
$tab_array[] = array(gettext("Settings"), false, "/pkg_edit.php?xml=openbgpd.xml&id=0");
$tab_array[] = array(gettext("Neighbors"), false, "/pkg.php?xml=openbgpd_neighbors.xml");
$tab_array[] = array(gettext("Groups"), false, "/pkg.php?xml=openbgpd_groups.xml");
$tab_array[] = array(gettext("Raw config"), true, "/openbgpd_raw.php");
$tab_array[] = array(gettext("Status"), false, "/openbgpd_status.php");
display_top_tabs($tab_array);

if ($savemsg) {
	print_info_box($savemsg);
}

$form = new Form();
$section = new Form_Section('OpenBGPD Configuration File');

$bgpconfig = new Form_Textarea(
	'openbgpd_raw',
	'Raw Configuration',
	$openbgpd_raw
);
$bgpconfig->setWidth(7);
$bgpconfig->setAttribute("rows", "30");
$bgpconfig->setAttribute("wrap", "off");
$bgpconfig->setHelp('The raw contents of the OpenBGPd configuration. View or edit the raw bgpd.conf as needed.');

$section->addInput($bgpconfig);

$form->add($section);

print($form);

?>
<div class="infoblock">
	<?=print_info_box(gettext('Once "Save" is clicked, the values entered in the "Settings", "Neighbors" and "Groups" tabs above will be overridden with this configuration.') . '<br/>' .
				gettext('To revert to the configuration generated by the GUI settings, save this form with empty input.') . '<br/>', 'info')?>
</div>
<?php include("foot.inc"); ?>
